Index: trunk/sources/HeuristicLab.Common/3.2/HeuristicLab.Common-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.Common/3.2/HeuristicLab.Common-3.2.csproj	(revision 2315)
+++ trunk/sources/HeuristicLab.Common/3.2/HeuristicLab.Common-3.2.csproj	(revision 2316)
@@ -65,5 +65,4 @@
   <ItemGroup>
     <Compile Include="HeuristicLabCommonPlugin.cs" />
-    <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
   <ItemGroup>
@@ -74,6 +73,6 @@
   </ItemGroup>
   <ItemGroup>
+    <None Include="Properties\AssemblyInfo.frame" />
     <None Include="HeuristicLab.snk" />
-    <None Include="Properties\AssemblyInfo.frame" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: trunk/sources/HeuristicLab.Common/3.2/Properties/AssemblyInfo.frame
===================================================================
--- trunk/sources/HeuristicLab.Common/3.2/Properties/AssemblyInfo.frame	(revision 2316)
+++ trunk/sources/HeuristicLab.Common/3.2/Properties/AssemblyInfo.frame	(revision 2316)
@@ -0,0 +1,58 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+using HeuristicLab.PluginInfrastructure;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Common")]
+[assembly: AssemblyDescription("Auxiliary HeuristicLab classes")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2008 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("f1962e16-e911-49fa-a685-1bb0a2a86526")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Revision and Build Numbers 
+// by using the '*' as shown below:
+[assembly: AssemblyVersion("3.2.0.$WCREV$")]
+[assembly: AssemblyFileVersion("3.2.0.$WCREV$")]
+[assembly: AssemblyBuildDate("$WCNOW$")]
Index: trunk/sources/HeuristicLab.sln
===================================================================
--- trunk/sources/HeuristicLab.sln	(revision 2315)
+++ trunk/sources/HeuristicLab.sln	(revision 2316)
@@ -250,8 +250,7 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.SparseMatrix-3.2", "HeuristicLab.SparseMatrix\3.2\HeuristicLab.SparseMatrix-3.2.csproj", "{1263BB36-1F20-4960-A5CB-530746DBAD77}"
 EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Common-3.2", "HeuristicLab.Common\3.2\HeuristicLab.Common-3.2.csproj", "{1FC004FC-59AF-4249-B1B6-FF25873A20E4}"
+EndProject
 Global
-	GlobalSection(TestCaseManagementSettings) = postSolution
-		CategoryFile = HeuristicLab1.vsmdi
-	EndGlobalSection
 	GlobalSection(SolutionConfigurationPlatforms) = preSolution
 		CEDMA Debug|Any CPU = CEDMA Debug|Any CPU
@@ -3996,4 +3995,34 @@
 		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Visualization Debug|x64.ActiveCfg = Debug|Any CPU
 		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.CEDMA Debug|x64.ActiveCfg = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.CEDMA Debug|x86.ActiveCfg = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.CEDMA Debug|x86.Build.0 = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Debug|x64.ActiveCfg = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Debug|x86.ActiveCfg = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Debug|x86.Build.0 = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Modeling Debug|x64.ActiveCfg = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Modeling Debug|x86.ActiveCfg = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Modeling Debug|x86.Build.0 = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Release|Any CPU.Build.0 = Release|Any CPU
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Release|x64.ActiveCfg = Release|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Release|x86.ActiveCfg = Release|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Release|x86.Build.0 = Release|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.v3.2 Debug|x64.ActiveCfg = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.v3.2 Debug|x86.ActiveCfg = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.v3.2 Debug|x86.Build.0 = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Visualization Debug|x64.ActiveCfg = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Visualization Debug|x86.ActiveCfg = Debug|x86
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Visualization Debug|x86.Build.0 = Debug|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
@@ -4089,4 +4118,5 @@
 		{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1} = {410732DB-725A-4824-896B-C298978343C0}
 		{1263BB36-1F20-4960-A5CB-530746DBAD77} = {410732DB-725A-4824-896B-C298978343C0}
+		{1FC004FC-59AF-4249-B1B6-FF25873A20E4} = {410732DB-725A-4824-896B-C298978343C0}
 		{A9E282EA-180F-4233-B809-AEDF0787545C} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
Index: trunk/sources/HeuristicLab/CopyAssemblies.cmd
===================================================================
--- trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 2315)
+++ trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 2316)
@@ -20,4 +20,5 @@
 copy "%SolutionDir%\HeuristicLab.Charting.Data\3.2\%Outdir%\HeuristicLab.Charting.Data-3.2.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.Charting.Data\3.3\%Outdir%\HeuristicLab.Charting.Data-3.3.dll" .\plugins
+copy "%SolutionDir%\HeuristicLab.Common\3.2\%Outdir%\HeuristicLab.Common-3.2.dll" .\plugins 
 copy "%SolutionDir%\HeuristicLab.Common.Resources\3.2\%Outdir%\HeuristicLab.Common.Resources-3.2.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.Communication.Data\3.2\%Outdir%\HeuristicLab.Communication.Data-3.2.dll" .\plugins