Index: trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModel.cs
===================================================================
--- trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModel.cs	(revision 2321)
+++ trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModel.cs	(revision 2322)
@@ -39,5 +39,4 @@
       set { model = value; }
     }
-
 
     /// <summary>
Index: trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.Designer.cs	(revision 2321)
+++ trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.Designer.cs	(revision 2322)
@@ -50,6 +50,4 @@
       this.rho = new System.Windows.Forms.TextBox();
       this.svmTypeLabel = new System.Windows.Forms.Label();
-      this.costLabel = new System.Windows.Forms.Label();
-      this.nuLabel = new System.Windows.Forms.Label();
       this.kernelTypeLabel = new System.Windows.Forms.Label();
       this.gammaLabel = new System.Windows.Forms.Label();
@@ -57,6 +55,4 @@
       this.kernelType = new System.Windows.Forms.TextBox();
       this.gamma = new System.Windows.Forms.TextBox();
-      this.cost = new System.Windows.Forms.TextBox();
-      this.nu = new System.Windows.Forms.TextBox();
       this.SuspendLayout();
       // 
@@ -104,22 +100,4 @@
       this.svmTypeLabel.Text = "SVM Type:";
       // 
-      // costLabel
-      // 
-      this.costLabel.AutoSize = true;
-      this.costLabel.Location = new System.Drawing.Point(2, 137);
-      this.costLabel.Name = "costLabel";
-      this.costLabel.Size = new System.Drawing.Size(31, 13);
-      this.costLabel.TabIndex = 5;
-      this.costLabel.Text = "Cost:";
-      // 
-      // nuLabel
-      // 
-      this.nuLabel.AutoSize = true;
-      this.nuLabel.Location = new System.Drawing.Point(3, 163);
-      this.nuLabel.Name = "nuLabel";
-      this.nuLabel.Size = new System.Drawing.Size(24, 13);
-      this.nuLabel.TabIndex = 6;
-      this.nuLabel.Text = "Nu:";
-      // 
       // kernelTypeLabel
       // 
@@ -164,26 +142,8 @@
       this.gamma.TabIndex = 12;
       // 
-      // cost
-      // 
-      this.cost.Location = new System.Drawing.Point(144, 134);
-      this.cost.Name = "cost";
-      this.cost.ReadOnly = true;
-      this.cost.Size = new System.Drawing.Size(100, 20);
-      this.cost.TabIndex = 14;
-      // 
-      // nu
-      // 
-      this.nu.Location = new System.Drawing.Point(144, 160);
-      this.nu.Name = "nu";
-      this.nu.ReadOnly = true;
-      this.nu.Size = new System.Drawing.Size(100, 20);
-      this.nu.TabIndex = 15;
-      // 
       // SVMModelView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.nu);
-      this.Controls.Add(this.cost);
       this.Controls.Add(this.gamma);
       this.Controls.Add(this.kernelType);
@@ -191,6 +151,4 @@
       this.Controls.Add(this.gammaLabel);
       this.Controls.Add(this.kernelTypeLabel);
-      this.Controls.Add(this.nuLabel);
-      this.Controls.Add(this.costLabel);
       this.Controls.Add(this.svmTypeLabel);
       this.Controls.Add(this.rho);
@@ -199,5 +157,5 @@
       this.Controls.Add(this.numberSupportVectorsLabel);
       this.Name = "SVMModelView";
-      this.Size = new System.Drawing.Size(253, 189);
+      this.Size = new System.Drawing.Size(253, 135);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -212,6 +170,4 @@
     private System.Windows.Forms.TextBox rho;
     private System.Windows.Forms.Label svmTypeLabel;
-    private System.Windows.Forms.Label costLabel;
-    private System.Windows.Forms.Label nuLabel;
     private System.Windows.Forms.Label kernelTypeLabel;
     private System.Windows.Forms.Label gammaLabel;
@@ -219,6 +175,4 @@
     private System.Windows.Forms.TextBox kernelType;
     private System.Windows.Forms.TextBox gamma;
-    private System.Windows.Forms.TextBox cost;
-    private System.Windows.Forms.TextBox nu;
   }
 }
Index: trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.cs
===================================================================
--- trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.cs	(revision 2321)
+++ trunk/sources/HeuristicLab.SupportVectorMachines/3.2/SVMModelView.cs	(revision 2322)
@@ -49,6 +49,4 @@
       kernelType.Text = model.Model.Parameter.KernelType.ToString();
       gamma.Text = model.Model.Parameter.Gamma.ToString();
-      cost.Text = model.Model.Parameter.C.ToString();
-      nu.Text = model.Model.Parameter.Nu.ToString();
     }
   }