Index: /trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IMainForm.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IMainForm.cs	(revision 2333)
+++ /trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IMainForm.cs	(revision 2334)
@@ -25,4 +25,5 @@
 using System.Text;
 using System.Drawing;
+using System.Windows.Forms;
 
 namespace HeuristicLab.MainForm {
@@ -30,4 +31,6 @@
     string Title { get; set; }
     string StatusStripText { get; set; }
+    bool StatusStripProgressBarVisible { get; set; }
+
     Icon Icon { get; set; } 
 
Index: /trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.Designer.cs	(revision 2333)
+++ /trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.Designer.cs	(revision 2334)
@@ -27,5 +27,6 @@
       this.toolStrip = new System.Windows.Forms.ToolStrip();
       this.statusStrip = new System.Windows.Forms.StatusStrip();
-      this.statusStripLabel = new System.Windows.Forms.ToolStripStatusLabel();
+      this.toolStripProgressBar = new System.Windows.Forms.ToolStripProgressBar();
+      this.toolStripStatusLabel = new System.Windows.Forms.ToolStripStatusLabel();
       this.statusStrip.SuspendLayout();
       this.SuspendLayout();
@@ -49,5 +50,6 @@
       // 
       this.statusStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
-            this.statusStripLabel});
+            this.toolStripProgressBar,
+            this.toolStripStatusLabel});
       this.statusStrip.Location = new System.Drawing.Point(0, 390);
       this.statusStrip.Name = "statusStrip";
@@ -56,8 +58,16 @@
       this.statusStrip.Text = "statusStrip";
       // 
-      // statusStripLabel
+      // toolStripProgressBar
       // 
-      this.statusStripLabel.Name = "statusStripLabel";
-      this.statusStripLabel.Size = new System.Drawing.Size(0, 17);
+      this.toolStripProgressBar.Name = "toolStripProgressBar";
+      this.toolStripProgressBar.Size = new System.Drawing.Size(100, 16);
+      this.toolStripProgressBar.Style = System.Windows.Forms.ProgressBarStyle.Marquee;
+      this.toolStripProgressBar.Visible = false;
+      // 
+      // toolStripStatusLabel
+      // 
+      this.toolStripStatusLabel.Name = "toolStripStatusLabel";
+      this.toolStripStatusLabel.Size = new System.Drawing.Size(112, 17);
+      this.toolStripStatusLabel.Text = "toolStripStatusLabel";
       // 
       // MainFormBase
@@ -82,6 +92,7 @@
     private System.Windows.Forms.ToolStrip toolStrip;
     private System.Windows.Forms.StatusStrip statusStrip;
-    private System.Windows.Forms.ToolStripStatusLabel statusStripLabel;
     protected System.Windows.Forms.MenuStrip menuStrip;
+    private System.Windows.Forms.ToolStripProgressBar toolStripProgressBar;
+    private System.Windows.Forms.ToolStripStatusLabel toolStripStatusLabel;
   }
 }
Index: /trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.cs	(revision 2333)
+++ /trunk/sources/HeuristicLab.MainForm/3.2/MainFormBase.cs	(revision 2334)
@@ -38,4 +38,5 @@
       views = new List<IView>();
       toolStripItems = new List<IToolStripItem>();
+      this.StatusStripText = "";
     }
 
@@ -61,5 +62,5 @@
 
     public string StatusStripText {
-      get { return this.statusStripLabel.Text; }
+      get { return this.toolStripStatusLabel.Text; }
       set {
         if (InvokeRequired) {
@@ -67,5 +68,16 @@
           Invoke(action, new object[] { value });
         } else
-          this.statusStripLabel.Text = value;
+          this.toolStripStatusLabel.Text = value;
+      }
+    }
+
+    public bool StatusStripProgressBarVisible  {
+      get { return this.toolStripProgressBar.Visible; }
+      set {
+        if (InvokeRequired) {
+          Action<bool> action = delegate(bool b) { this.toolStripProgressBar.Visible = b; };
+          Invoke(action, new object[] { value });
+        } else
+          this.toolStripProgressBar.Visible = value;
       }
     }