Index: trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/AccuracyEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/AccuracyEvaluator.cs	(revision 2344)
+++ 	(revision )
@@ -1,72 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.DataAnalysis;
-
-namespace HeuristicLab.GP.StructureIdentification.Classification {
-  public class AccuracyEvaluator : GPClassificationEvaluatorBase {
-    private const double EPSILON = 1.0E-6;
-    public override string Description {
-      get {
-        return @"Calculates the total accuracy of the model (ratio of correctly classified instances to total number of instances) given a model and the list of possible target class values.";
-      }
-    }
-
-    public AccuracyEvaluator()
-      : base() {
-      AddVariableInfo(new VariableInfo("Accuracy", "The total accuracy of the model (ratio of correctly classified instances to total number of instances)", typeof(DoubleData), VariableKind.New));
-    }
-
-    public override void Evaluate(IScope scope, ITreeEvaluator evaluator, Dataset dataset, int targetVariable, double[] classes, double[] thresholds, int start, int end) {
-      DoubleData accuracy = GetVariableValue<DoubleData>("Accuracy", scope, false, false);
-      if (accuracy == null) {
-        accuracy = new DoubleData();
-        scope.AddVariable(new HeuristicLab.Core.Variable(scope.TranslateName("Accuracy"), accuracy));
-      }
-
-      int nSamples = end - start;
-      int nCorrect = 0;
-      for (int sample = start; sample < end; sample++) {
-        double est = evaluator.Evaluate(sample);
-        double origClass = dataset.GetValue(sample, targetVariable);
-        double estClass = double.NaN;
-        // if estimation is lower than the smallest threshold value -> estimated class is the lower class
-        if (est < thresholds[0]) estClass = classes[0];
-        // if estimation is larger (or equal) than the largest threshold value -> estimated class is the upper class
-        else if (est >= thresholds[thresholds.Length - 1]) estClass = classes[classes.Length - 1];
-        else {
-          // otherwise the estimated class is the class which upper threshold is larger than the estimated value
-          for (int k = 0; k < thresholds.Length; k++) {
-            if (thresholds[k] > est) {
-              estClass = classes[k];
-              break;
-            }
-          }
-        }
-        if (Math.Abs(estClass - origClass) < EPSILON) nCorrect++;
-      }
-      accuracy.Data = nCorrect / (double)nSamples;
-    }
-  }
-}
Index: trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/ConfusionMatrixEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/ConfusionMatrixEvaluator.cs	(revision 2344)
+++ 	(revision )
@@ -1,76 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-
-namespace HeuristicLab.GP.StructureIdentification.Classification {
-  public class ConfusionMatrixEvaluator : GPClassificationEvaluatorBase {
-    public override string Description {
-      get {
-        return @"Calculates the classifcation matrix of the model.";
-      }
-    }
-
-    public ConfusionMatrixEvaluator()
-      : base() {
-      AddVariableInfo(new VariableInfo("ConfusionMatrix", "The confusion matrix of the model", typeof(IntMatrixData), VariableKind.New));
-    }
-
-    public override void Evaluate(IScope scope, ITreeEvaluator evaluator, HeuristicLab.DataAnalysis.Dataset dataset, int targetVariable, double[] classes, double[] thresholds, int start, int end) {
-      IntMatrixData matrix = GetVariableValue<IntMatrixData>("ConfusionMatrix", scope, false, false);
-      if (matrix == null) {
-        matrix = new IntMatrixData(new int[classes.Length, classes.Length]);
-        scope.AddVariable(new HeuristicLab.Core.Variable(scope.TranslateName("ConfusionMatrix"), matrix));
-      }
-
-      int nSamples = end - start;
-      for (int sample = start; sample < end; sample++) {
-        double est = evaluator.Evaluate(sample);
-        double origClass = dataset.GetValue(sample, targetVariable);
-        int estClassIndex = -1;
-        // if estimation is lower than the smallest threshold value -> estimated class is the lower class
-        if (est < thresholds[0]) estClassIndex = 0;
-        // if estimation is larger (or equal) than the largest threshold value -> estimated class is the upper class
-        else if (est >= thresholds[thresholds.Length - 1]) estClassIndex = classes.Length - 1;
-        else {
-          // otherwise the estimated class is the class which upper threshold is larger than the estimated value
-          for (int k = 0; k < thresholds.Length; k++) {
-            if (thresholds[k] > est) {
-              estClassIndex = k;
-              break;
-            }
-          }
-        }
-
-        // find the first threshold index that is larger to the original value
-        int origClassIndex = classes.Length - 1;
-        for (int i = 0; i < thresholds.Length; i++) {
-          if (origClass < thresholds[i]) {
-            origClassIndex = i;
-            break;
-          }
-        }
-        matrix.Data[origClassIndex, estClassIndex]++;
-      }
-    }
-  }
-}
Index: trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/DefaultClassificationAlgorithmOperators.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/DefaultClassificationAlgorithmOperators.cs	(revision 2344)
+++ trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/DefaultClassificationAlgorithmOperators.cs	(revision 2351)
@@ -37,21 +37,18 @@
       subScopesProc.AddSubOperator(individualProc);
       seq.AddSubOperator(subScopesProc);
-      AccuracyEvaluator trainingAccuracy = new AccuracyEvaluator();
+      SimpleAccuracyEvaluator trainingAccuracy = new SimpleAccuracyEvaluator();
       trainingAccuracy.Name = "TrainingAccuracyEvaluator";
       trainingAccuracy.GetVariableInfo("Accuracy").ActualName = "TrainingAccuracy";
-      trainingAccuracy.GetVariableInfo("SamplesStart").ActualName = "TrainingSamplesStart";
-      trainingAccuracy.GetVariableInfo("SamplesEnd").ActualName = "TrainingSamplesEnd";
+      trainingAccuracy.GetVariableInfo("Values").ActualName = "TrainingValues";
 
-      AccuracyEvaluator validationAccuracy = new AccuracyEvaluator();
+      SimpleAccuracyEvaluator validationAccuracy = new SimpleAccuracyEvaluator();
       validationAccuracy.Name = "ValidationAccuracyEvaluator";
       validationAccuracy.GetVariableInfo("Accuracy").ActualName = "ValidationAccuracy";
-      validationAccuracy.GetVariableInfo("SamplesStart").ActualName = "ValidationSamplesStart";
-      validationAccuracy.GetVariableInfo("SamplesEnd").ActualName = "ValidationSamplesEnd";
+      validationAccuracy.GetVariableInfo("Values").ActualName = "ValidationValues";
 
-      AccuracyEvaluator testAccuracy = new AccuracyEvaluator();
+      SimpleAccuracyEvaluator testAccuracy = new SimpleAccuracyEvaluator();
       testAccuracy.Name = "TestAccuracyEvaluator";
       testAccuracy.GetVariableInfo("Accuracy").ActualName = "TestAccuracy";
-      testAccuracy.GetVariableInfo("SamplesStart").ActualName = "TestSamplesStart";
-      testAccuracy.GetVariableInfo("SamplesEnd").ActualName = "TestSamplesEnd";
+      testAccuracy.GetVariableInfo("Values").ActualName = "TestValues";
 
       individualProc.AddSubOperator(trainingAccuracy);
Index: trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/HeuristicLab.GP.StructureIdentification.Classification-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/HeuristicLab.GP.StructureIdentification.Classification-3.3.csproj	(revision 2344)
+++ trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/HeuristicLab.GP.StructureIdentification.Classification-3.3.csproj	(revision 2351)
@@ -80,8 +80,5 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="AccuracyEvaluator.cs" />
     <Compile Include="ClassificationMeanSquaredErrorEvaluator.cs" />
-    <Compile Include="ConfusionMatrixEvaluator.cs" />
-    <Compile Include="TargetClassesCalculator.cs" />
     <Compile Include="DefaultClassificationAlgorithmOperators.cs" />
     <Compile Include="GPClassificationEvaluatorBase.cs" />
Index: trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/TargetClassesCalculator.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/TargetClassesCalculator.cs	(revision 2344)
+++ 	(revision )
@@ -1,51 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.DataAnalysis;
-using System.Linq;
-
-namespace HeuristicLab.GP.StructureIdentification.Classification {
-  public class TargetClassesCalculator : OperatorBase {
-
-    public TargetClassesCalculator()
-      : base() {
-      AddVariableInfo(new VariableInfo("Dataset", "The dataset", typeof(Dataset), VariableKind.In));
-      AddVariableInfo(new VariableInfo("TargetVariable", "Index of the target variable", typeof(IntData), VariableKind.In));
-      AddVariableInfo(new VariableInfo("TargetClassValues", "The original class values of target variable (for instance negative=0 and positive=1).", typeof(ItemList<DoubleData>), VariableKind.New));
-    }
-
-    public override IOperation Apply(IScope scope) {
-      Dataset dataset = GetVariableValue<Dataset>("Dataset", scope, true);
-      int targetVariable = GetVariableValue<IntData>("TargetVariable", scope, true).Data;
-
-      ItemList<DoubleData> classes = new ItemList<DoubleData>();
-      foreach(double x in dataset.GetVariableValues(targetVariable).Distinct().OrderBy(v=>v)) {
-        classes.Add(new DoubleData(x));
-      }
-
-      scope.AddVariable(new HeuristicLab.Core.Variable(scope.TranslateName("TargetClassValues"), classes));
-      return null;
-    }
-  }
-}